//+------------------------------------------------------------------+
//|                                     Qx Basic Market Template.mq4 |
//|                                   Copyright  2009, Quantum Xcel |
//|                                       http://www.quantumxcel.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, version 1.09 Quantum Xcel"
#property link      "http://www.quantumxcel.com"
#include <stdlib.mqh>
#include <stderror.mqh>
//__________________________________________________________________
// General Use
//Set Up for $10,000 AccountBalance
//Recommended initial lot size is 1 lot per 100,000 of account balance
//Manually adjust fixed lot size to this ratio weekly
//____________________________________________________________________

extern string              Global = "Global Variables";
extern int            MagicNumber = 000001;       //Change this number for different charts on same platform
extern int               Slippage = 3;
extern double            BarCheck = 0.001;

extern string         DAY_TRADING = "Set the Single Position Trading Limits";

extern string       BalanceChange = "No more orders will be placed if Balance changes from InitialBalance";
extern bool        UseBalanceStop = False;
extern double      InitialBalance = 50000.0;
extern double           BalChange = 10.0;

extern string        PandLTargets = "Daily Profit and Loss Targets";
extern bool         UseIBCloseAll = False;
extern double            DPTarget = 500.0;
extern double            DLTarget = 500.0;

extern string    EXTENDED_TRADING = "Set restrictions on extended trades by trade time limits and profits";

extern string          TradeTimes = "Set EA to trade or not trade on Fridays, Days or Nights";
extern string         TradeFriday = "Set to true for NO TRADES on Friday";
extern bool         NoTradeFriday = False;
extern string         TradeOnDays = "Set to true to trade on Days Only 0700 to 1800";
extern bool             TradeDays = False;
extern string       TradeOnNights = "Set to true to trade on Nights Only 1800 to 700";
extern bool           TradeNights = False;

extern string       BalanceProfit = "No more orders will be placed if Balance Target is reached";
extern bool      UseBalanceProfit = False;
extern double       BalanceTarget = 60000.0;

extern string    MONEY_MANAGEMENT = "Set Money Management Inputs";

extern string           MinEquity = "Expert will stop trading if Equity falls below set amount - set at 10% to 20% Account Balance";
extern bool          UseEPToClose = True; 
extern double       MinimumEquity = 5000.0;

extern string           FixedLots = "Use Fixed Lot Sizing set MM to False";
extern double                Lots = 0.1;     //Fixed Lot Size if MM set to False

extern string       ManageLotSize = "Set To True to Turn On MM Lot Sizing";
extern bool      Money_Management = False;   //True to turn on lot sizing

extern string                 LST = "1 - Lots to Protected Balance, 2 - EP regulated Lot Sizing";
extern int              LotSizing = 1;       //Select Lot Sizing Type

extern string      BalanceProtect = "Type 1 Lot Size to Protected Balance Amount";
extern double      BalancePercent = 10.0;    //100 Maximum Percentage of Balance to use for Lotsizing
extern double         LotsPercent = 5.0;     //100 Maximum Lots percentage to protected balance

extern string        EPIncrements = "Type 2 Lot Sizing by EP Commitment"; 
extern double        EPPercentage = 100.0;

extern string     LotsToMaxTrades = "Adjust Lot Sizes by the Number of positions taken"; 
extern bool       UseTradesAdjust = False; 

extern string     AssetAllocation = "Increment Lot Size Relative to WinLoss Ratio";
extern bool           KellySystem = False;    //Set to True to increment lot sizes on wins.
extern int                PastWin = 2;          
extern int               PastLoss = 2;          

extern string           CloseOnWL = "Shut down EA with low win loss percentage";
extern bool            UseWLClose = False;
extern double         MinWPercent = 0.05;

extern string   MARTINGALE_ORDERS = "Set the Martingale Order Inputs"; 
    
extern string              SeqEXP = "Use Sequencial Martingale and all other Martingale features";
extern bool                UseEXP = True; 

extern string     IncrementLosses = "Increment lot size on Losses";     
extern bool            UseIncLoss = True;
extern double            LossBase = 1.8;

extern string       IncrementTPSL = "Adjust Stop Loss on Each Order by Declining Increments";
extern bool            AdjustTPSL = False;
extern double            TPSLPips = 0.0005;

extern string     LimitIncrements = "Limit the number of Sequencial increments and stay at SeqLimit";     
extern bool           UseLimitInc = True;
extern string   RestartIncrements = "Limit the number of Sequencial increments and then restart sequence";
extern bool         UseRestartInc = False;
extern string    StopOnIncrements = "Limit the number of Sequencial increments and Stop Program";
extern bool        UseShutDownInc = False;
extern string         SetSeqLimit = "CHOOSE ONLY ONE FEATURE ONLY - ALL TRUE WILL CANCEL ALL";
extern int               SeqLimit = 5;

extern string  MARTINGALE_PROTECT = "Set Martingale protection inputs";

extern string        StopFreeMarg = "Shut Down when Free Margin reaches FMLimit percent of Account Balance";
extern bool            UseFMLimit = True;  
extern double             FMLimit = 0.10;
extern double              FMStop = 20.0;

extern string     SetLotSizeLimit = "Set Martingale Maximum Lot Size relative to Account Balance";
extern bool          UseLotLimits = True;
extern double     LotLimitPercent = 50.0;
 
extern string     PRIMIARY_ORDERS = "Set the Primary Order Inputs"; 
 
extern string           UseTPorSL = "Select to Use Take Profit or Stop Loss on All Orders";
extern bool         UseTakeProfit = True;
extern bool           UseStopLoss = True;

extern string       PrimaryOrders = "Turn on or Activate a Market Buy or Sell Order";
extern bool                UseBuy = True;
extern bool               UseSell = True;

extern string   PrimaryTakeProfit = "Set Primary Market Order Take Profit";
extern double          TakeProfit = 0.04;

extern string    PrimiaryStopLoss = "Set Primary Market Order Stop Loss";
extern double            StopLoss = 0.015;

extern string      TRAILING_STOPS = "Set the Secondary Order Inputs";

extern string           TrailStop = "Turn on Trailing Stop";
extern bool       UseTrailingStop = False;
extern string       BarsToNewStop = "Bars from Present Bar to New Stop Setting";
extern int                  TSBar = 2;    
extern string       StopLossClear = "Number of Pips to Clear from Previous Stop Setting";
extern double             TSClear = 0.002;
  
extern string    SECONDARY_ORDERS = "Set the Secondary Order Inputs";

extern string   MaxNumberOfTrades = "Choose the Number of Positions to Take";
extern int              MaxTrades = 1;

extern string       MXOn2ndOrders = "Use a Multiplier on Lot Size of Price Move Orders";
extern bool         UseMultiplier = False;
extern double          Multiplier = 3.0;

extern string       MaxOutLotSize = "Place maximum allowed lot size on secondary orders";
extern bool         UseLotsMaxOut = False;

extern string         PipsToOrder = "Set the Number of Pips to the Next Order for All Secondary Orders";
extern double           PriceMove = 0.005;

extern string     PriceMoveOrders = "Additional Orders are placed with Market Direction";
extern bool           PriceOrders = False;

extern string    PriceMoveTPandSL = "Automatically Set at Primiary Take Profit and StopLoss";

extern string       HEDGE_PROTECT = "Protect down side by placing hedge position";

extern string     PrimiaryProtect = "Turn On to Excute Take Opposite Position Hedging Orders";
extern bool       UseOrderProtect = False;

extern string   ProtectTakeProfit = "Set Separate Take Profit on Hedge Orders";
extern double         PTakeProfit = 0.003;

extern string             ENTRIES = "Select Entry Parameter Type";

extern string         HeikenEntry = "Use Heiken Ashi Indicator to initiate orders";
extern bool         HAEntryMedium = False;
extern bool           HAEntrySlow = False;

extern string         MedianEntry = "Use Median Indicator to initiate orders";
extern bool     MedianEntryMedium = True;
extern bool       MedianEntrySlow = False;

extern string        EntryMinutes = "Use Entry Minutes";
extern int               EnterMin = 10;

extern string        RunTestEntry = "Simple Median Order Trigger for Testing EA operation";
extern bool             TestEntry = False;

extern string       EXIT_STRATEGY = "Choose Exit Strategy";

extern string          HeikenExit = "Use Heiken Ashi Indicator to close orders";
extern bool          HAExitMedium = False;
extern bool            HAExitSlow = False;

extern string          MedianExit = "Use Heiken Ashi Indicator to close orders";
extern bool      MedianExitMedium = True;
extern bool        MedianExitSlow = False;

extern string         ExitMinutes = "Use Exit Minutes";
extern int                ExitMin = 5;

extern string     ReverseMoveExit = "Close all orders when there is a sudden reversal against order position";
extern bool               RevExit = False;
extern int             ExitRevMin = 19;
extern double           RevSpread = 0.0025;

extern string         RunTestExit = "Simple Median Order Trigger for Testing EA operation";
extern bool              TestExit = False;

extern string          INDICATORS = "Modify Indicator Parameters";

extern string            NoInputs = "There are no Variables on this Indicator Trigger";


//+------------------------------------------------------------------+
//| Global Definitions                                               |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Initialization                                                   |
//+-----------------------------------------------------------------+
int init()
 {   
 return(0);
 } 
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
 {
 return(0);
 }
 
//+------------------------------------------------------------------+
//| Close All Function                                               |
//+------------------------------------------------------------------+
int CloseAll()
   { 
  while(OrdersTotal()>0)
   {
      OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      switch (OrderType())
      {
      case OP_BUY: OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), 4, Purple); break;
      case OP_SELL: OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), 4, Purple); break;
      case OP_BUYSTOP:OrderDelete(OrderTicket());
      case OP_SELLSTOP:OrderDelete(OrderTicket()); 
      case OP_BUYLIMIT:OrderDelete(OrderTicket());
      case OP_SELLLIMIT: OrderDelete(OrderTicket());
      }
   }
   Sleep(10000);
   RefreshRates();
   return(OrderType()==0);
 }
  
//+------------------------------------------------------------------+
//| Close All Buys                                                   |
//+------------------------------------------------------------------+
int CloseAllBuys()
   {
   
  while(OrdersTotal()>0)
   {
      OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      switch (OrderType())
      {
      case OP_BUY: OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), 4, Purple); break;
      case OP_BUYSTOP:OrderDelete(OrderTicket());      
      case OP_BUYLIMIT:OrderDelete(OrderTicket());     
      }
   }
   Sleep(10000);
   RefreshRates();
   return(OrderType()==0);  
 }

//+------------------------------------------------------------------+
//| Close All Sells                                               |
//+------------------------------------------------------------------+
int CloseAllSells()
   { 
   while(OrdersTotal()>0)
     {
      OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      switch (OrderType())
      { 
      case OP_SELL: OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), 4, Purple); break;
      case OP_SELLSTOP:OrderDelete(OrderTicket()); 
      case OP_SELLLIMIT: OrderDelete(OrderTicket());
      }
    }
    Sleep(10000);
   RefreshRates();
   return(OrderType()==0);   
  }
   
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
//+------------------------------------------------------------------+
//|Display Account Information                                       |
//+------------------------------------------------------------------+    

   double MinLots          = MarketInfo(Symbol(), MODE_MINLOT); //Minimum lot size for account type
   double MaxLots          = MarketInfo(Symbol(), MODE_MAXLOT);
   double LotSize          = MarketInfo(Symbol(), MODE_LOTSIZE); //The value of a lot for account type 100,000 for standard
   double MarginRequired   = MarketInfo(Symbol(), MODE_MARGINREQUIRED);   
   double StopLevel        = MarketInfo(Symbol(), MODE_STOPLEVEL);// MINIMUM PIPS OVER OR UNDER CURRENT MARKET PRICE FOR PENDING ORDER PRICE.  
   double FreeMargin       = AccountFreeMargin();
   double Margin           = AccountMargin();
   double Equity           = AccountEquity();
   double Balance          = AccountBalance();
   int AcctLeverage        = AccountLeverage();
   int  Ticket             = OrderTicket();
   int TotalOrders         = OrdersTotal();
   int Hours               = Hour();
   int Minutes             = Minute();
   int   h                 = TimeHour(TimeCurrent());
   datetime Bartime        = iTime( NULL,0,0);           

//+------------------------------------------------------------------+
//| Order Text                                                       |
//+------------------------------------------------------------------+ 
string Text1;
Text1="Qx Basic Buy";  
string Text2;
Text2="Qx Basic Sell";  
string Text3;
Text3="Qx Basic Pending Buy";  
string Text4;
Text4="Qx Basic Pending Sell";  
string Text5;
Text5="Qx Price Move Buy";  
string Text6;
Text6="Qx Price Move Sell";  
string Text7;
Text7="Qx Protect Buy";  
string Text8;
Text8="Qx Protect Sell"; 
 
//+------------------------------------------------------------------+
//| Set Lot Size Digits                                              |
//+------------------------------------------------------------------+ 
if(MinLots==0.1)
{
int DigitsAllowed=1;
}
else
{
DigitsAllowed=2;
}
//+------------------------------------------------------------------+
//| Profit Targeting                                                 |
//+------------------------------------------------------------------+ 
if((Equity-Balance)>0)
    {
 double Profit = NormalizeDouble((Equity-Balance),0);
    }
   
if((Balance-Equity)>0)
    {   
 double Loss = NormalizeDouble((Balance-Equity),0); 
    }
   double PReturn  = NormalizeDouble(Profit/Balance,2);
   double LReturn  = NormalizeDouble(Loss/Balance,2);
//+------------------------------------------------------------------+
//| Close on Equity Target                                           |
//+------------------------------------------------------------------+
 if(UseBalanceProfit)
    {    
    if(Equity>BalanceTarget)
       {
      CloseAll();
       }
    } 
//+------------------------------------------------------------------+
//| Close on Equity Protection                                       |
//+------------------------------------------------------------------+
  if(UseEPToClose)
     {        
     if(Equity<MinimumEquity)
        {
       CloseAll();
        }
      }     
//+------------------------------------------------------------------+
//| Close on Target Profit and Loss                                  |
//+------------------------------------------------------------------+
if(UseIBCloseAll)
   {  
   if(Profit>DPTarget || Loss>DLTarget)  
      {
     CloseAll();
      }
   } 
//+------------------------------------------------------------------+
//| Close on Free Margin                                             |
//+------------------------------------------------------------------+
if(UseFMLimit)
   {
   double FMBalance = NormalizeDouble((Balance*FMLimit),0);
   
   if(FreeMargin<FMBalance)  
      {
     CloseAll();
      }      
   }

//+------------------------------------------------------------------+
//| Money Management                                                 |
//+------------------------------------------------------------------+
double lotsi=0;
//COMMON VARIABLES FOR RISK LOT SIZING
double AvailBalance        = Balance;

//VARIABLES FOR BALANCE PROTECTION LOT SIZING
double BalancePercentage   = BalancePercent/100.0;
double ProtectedBalance    = BalancePercentage*AvailBalance;
double LotsPercentage      = LotsPercent/100.0;
double PBAvailable         = ProtectedBalance*LotsPercentage;
double PBLots              = PBAvailable/MarginRequired; 
 
//VARIABLES FOR EQUITY PROTECTION LOT SIZING
double EPPercent           = EPPercentage/100;
double EPAvailable         = Balance-MinimumEquity;
double EPAllocated         = EPAvailable*EPPercent;
double EPLots              = EPAllocated/MarginRequired;

double APBLots=PBLots;
double AEPLots=EPLots;

//VARIABLES FOR LIMITING LOT SIZES TO NUMBER OF POSITIONS
if(UseTradesAdjust)
   {  
   APBLots                 = PBLots/MaxTrades;
   AEPLots                 = EPLots/MaxTrades;
   }

   if(Money_Management)
   {
    switch(LotSizing)
      {     
      case 1:  lotsi=NormalizeDouble(APBLots,DigitsAllowed);break;
      case 2:  lotsi=NormalizeDouble(AEPLots,DigitsAllowed);break;
      default: lotsi=Lots;
      }
   }
   else
     {
   lotsi=Lots;
     }
   if(lotsi<MarketInfo(Symbol(), MODE_MINLOT))
        {lotsi=MarketInfo(Symbol(), MODE_MINLOT);} //Make sure lotsi does not calculate less than the minimum broker lot size
   
   if(lotsi>MarketInfo(Symbol(), MODE_MAXLOT))
        {lotsi=MarketInfo(Symbol(), MODE_MAXLOT);} //Make sure lotsi does not calculate more than the maximum borker lot size  

         
//+------------------------------------------------------------------+
//|EXP Win Loss Management                                           |
//+------------------------------------------------------------------+
double AStopLoss=StopLoss;
double ATakeProfit=TakeProfit;
double MGlotsi=lotsi;

if(UseEXP)
  {
int Xwins=0;  
int Xlosses=0;
   
int x;
int hstxTotal=OrdersHistoryTotal();

      for( x=hstxTotal-1;x>=0;x--)
        {
         if(OrderSelect(x,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) Xlosses++;
        }
        
      for( x=hstxTotal-1;x>=0;x--)
        {
         if(OrderSelect(x,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) Xwins++;
         if(OrderProfit()<0) break;
        }

if(UseLimitInc)
   {
   if(Xlosses>=SeqLimit)
      {
      Xlosses=SeqLimit;
      }
   }
      
if(UseRestartInc)
   {
   if(Xlosses>=SeqLimit)
      {
      Xlosses=Xlosses-SeqLimit;
      }
   }
    
if(UseIncLoss)
   {    
  double XLossAdj = Xlosses;          
  double XLFactor = MathPow(LossBase,XLossAdj);
  MGlotsi = NormalizeDouble((lotsi*XLFactor),DigitsAllowed);  
   }      
  
if(AdjustTPSL)
   {
   double TSAddPips = XLossAdj*TPSLPips;
   AStopLoss=NormalizeDouble((StopLoss-TSAddPips),4);
   }
if(AStopLoss<=0.0015)
   {
   AStopLoss=0.0015;
   }      
 }

  if(MGlotsi<MarketInfo(Symbol(), MODE_MINLOT))
   {MGlotsi=MarketInfo(Symbol(), MODE_MINLOT);} //Make sure lotsi does not calculate less than the minimum broker lot size
   
  if(MGlotsi>MarketInfo(Symbol(), MODE_MAXLOT))
   {MGlotsi=MarketInfo(Symbol(), MODE_MAXLOT);}

//+------------------------------------------------------------------+
//|Kelly Win Loss Management                                         |
//+------------------------------------------------------------------+
int BWins=0;
int BLosses=0;
int SWins=0;
int SLosses=0;

   int i,hstTotal=OrdersHistoryTotal();
   for(i=0;i<hstTotal;i++)     
       {
       if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==True)
          {                    
          if(OrderType()==OP_SELL)
             {
             if(OrderSymbol()==Symbol())
                {              
                if(OrderMagicNumber()==MagicNumber)
                   { 
                   if(OrderProfit()<0)
                      {
                     SLosses++;
                      }
                   if(OrderProfit()>0)
                      {
                     SWins++;
                      }
                   }
                }
             }       
                             
          if(OrderType()==OP_BUY)
             {
             if(OrderSymbol()==Symbol())
                {                    
                if(OrderMagicNumber()==MagicNumber)
                   {                   
                   if(OrderProfit()<0)
                      {
                     BLosses++;
                      }
                   if(OrderProfit()>0)
                      {
                     BWins++;
                      }  
                   }
                }
             }    
          
       }
     } 
     
int    TotalWin     = BWins+SWins;
double TotalWins    = TotalWin+PastWin;
int    TotalLoss    = BLosses+SLosses;
double TotalLosses  = TotalLoss+PastLoss;
double TotalWL      = TotalWins+TotalLosses;

double WinLossR     = NormalizeDouble(TotalWins/TotalLosses,2);
double WinPercent   = NormalizeDouble(TotalWins/TotalWL,2);

//+------------------------------------------------------------------+
//| Close EA on Kelly Ratio                                             |
//+------------------------------------------------------------------+
  if(UseWLClose)
     {
     if(WinPercent<MinWPercent)
        {
       CloseAll();
        }
     }
//+------------------------------------------------------------------+
//|Kelly Win Loss Incrementing                                       |
//+------------------------------------------------------------------+    
double klotsi=lotsi;
          
 if(KellySystem)
    {   
   klotsi=NormalizeDouble((lotsi*WinLossR),DigitsAllowed);
    }
        
    if(klotsi<MarketInfo(Symbol(), MODE_MINLOT))
      {klotsi=MarketInfo(Symbol(), MODE_MINLOT);} //Make sure lotsi does not calculate less than the minimum broker lot size
    if(klotsi>MarketInfo(Symbol(), MODE_MAXLOT))
      {klotsi=MarketInfo(Symbol(), MODE_MAXLOT);}     
     
//+------------------------------------------------------------------+
//|Multiplier Lot Sizing                                             |
//+------------------------------------------------------------------+               
double mlotsi=lotsi;

   if(UseMultiplier)
      {
      if(LotSizing==2)
         {
        mlotsi=klotsi;
         }
        else
         {                              
        mlotsi=NormalizeDouble(lotsi*Multiplier,DigitsAllowed); 
         }
      } 
      
    if(mlotsi<MarketInfo(Symbol(), MODE_MINLOT))
      {mlotsi=MarketInfo(Symbol(), MODE_MINLOT);} //Make sure lotsi does not calculate less than the minimum broker lot size    
    if(mlotsi>MarketInfo(Symbol(), MODE_MAXLOT))
      {mlotsi=MarketInfo(Symbol(), MODE_MAXLOT);}             
//+------------------------------------------------------------------+
//|Limit Lot Size Maximum                                            |
//+------------------------------------------------------------------+
  double LLBalPercent      = LotLimitPercent/100.0;
  double LLBalAvailable    = Equity*LLBalPercent;
  double LLLots            = NormalizeDouble((LLBalAvailable/MarginRequired),DigitsAllowed);   
   
   if(LLLots>MarketInfo(Symbol(), MODE_MAXLOT))
   {LLLots=MarketInfo(Symbol(), MODE_MAXLOT);}

if(UseLotLimits)
   {     
     if(lotsi>LLLots)
        {
       lotsi=LLLots;
        }
     if(klotsi>LLLots)
        {
       klotsi=LLLots;
        }
     if(mlotsi>LLLots)
        {
       mlotsi=LLLots;
        }       
     if(MGlotsi>LLLots)
        {
       MGlotsi=LLLots;
        }                  
   }
//+------------------------------------------------------------------+
//|Max Out Secondary Orders                                          |
//+------------------------------------------------------------------+      
 double MXlotsi=lotsi; 
 
 if(UseLotsMaxOut)
   {
  MXlotsi=NormalizeDouble((LLLots-MGlotsi),DigitsAllowed);            
   }
   
  if(MXlotsi>MarketInfo(Symbol(), MODE_MAXLOT))
     {MXlotsi=MarketInfo(Symbol(), MODE_MAXLOT);}
              
double Plotsi=lotsi;
double PMlotsi=lotsi; 
                           
if(UseEXP)
   {
   Plotsi=MGlotsi;
   PMlotsi=MGlotsi;  
   }
   
if(UseLotsMaxOut)
   {
  PMlotsi=MXlotsi;
   }
   
if(UseMultiplier)
   {
   Plotsi=klotsi;
   PMlotsi=mlotsi;
   }

if(KellySystem)
   {
   Plotsi=klotsi;
   PMlotsi=klotsi;
   }
            
//+------------------------------------------------------------------+
//|Indicators                                                        |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|Order Tracking                                                    |
//+------------------------------------------------------------------+
int Buy=0;
int Sell=0;
int j;
int histTotal=OrdersTotal();
   
   for(j=0;j<histTotal;j++)     
       {
       if(OrderSelect(j,SELECT_BY_POS,MODE_TRADES)==True)
          {                    
          
          if(OrderType()==OP_SELL)
             {
             if(OrderSymbol()==Symbol())
                {              
                if(OrderMagicNumber()==MagicNumber)
                   { 
                  Sell++;   
                  double SellOrderPrice=OrderOpenPrice();
                  double SellTakeProfit=OrderTakeProfit();    
                  double SellStopLoss=OrderStopLoss();
                  int SellTicket=OrderTicket();
                  datetime SellTime=OrderOpenTime(); 
                                        
                   }
                 }
              }
     
          if(OrderType()==OP_BUY)
             {
             if(OrderSymbol()==Symbol())
                {                    
                if(OrderMagicNumber()==MagicNumber)
                   {                   
                  Buy++;   
                  double BuyOrderPrice=OrderOpenPrice(); 
                  double BuyTakeProfit=OrderTakeProfit();  
                  double BuyStopLoss=OrderStopLoss();
                  int BuyTicket=OrderTicket();
                  datetime BuyTime = OrderOpenTime();
                  
                   } 
                }
             }
       }
     }
//+------------------------------------------------------------------+
//|Display Information                                               |
//+------------------------------------------------------------------+    
Comment("Qx H1 EXPM Basic3D 1.08\n",            
        "Minute            = ",Minutes,"\n",                     
        "Buy Orders        = ",Buy,"\n", 
        "Sell Orders       = ",Sell,"\n",          
        "Total Orders      = ",TotalOrders,"\n",                        
        "Max Lots          = ",LLLots,"\n",       
        "lotsi Lots        = ",lotsi,"\n",
        "klotsi Lots       = ",klotsi,"\n",
        "mlotsi Lots       = ",mlotsi,"\n",        
        "MGlotsi Lots      = ",MGlotsi,"\n",        
        "Profit            = ",Profit,"\n",//Profit,"\n",  
        " Losses           = ",Loss,"\n",                                                                                                       
        "Win Loss Ratio    = ",WinLossR,"\n",         
        "Win Percent       = ",WinPercent,"\n",         
        "Acct Balance      = $",Balance,"\n",           //Display Account Balance
        "Acct Equity       = $",Equity,"\n",            //Display Account Equity
        "Free Margin       = $",FreeMargin,"\n",         //Display Account Free Margin                                                        
        "Min Lots          = ",MinLots,"\n", 
        "Max Lots          = ",MaxLots,"\n", 
        "Margin Ratio      = ",AcctLeverage,"\n", 
        "Margin To Lots    = ",MarginRequired);            //Display Broker maximum number of lots allowed      
//+------------------------------------------------------------------+
//|Exit Signals                                                      |
//+------------------------------------------------------------------+        
 
         
//+------------------------------------------------------------------+
//| Trailing Stops                                                   |
//+------------------------------------------------------------------+        

  if(UseTrailingStop)
     {
     if(OrdersTotal()>0)
        {     
//+------------------------------------------------------------------+
//|Trailing Stop Order Management                                    |
//+------------------------------------------------------------------+ 
      int cnt70=0;
                       
      for(cnt70 = OrdersTotal(); cnt70 >= 0; cnt70--)
          {      
          if(OrderSelect(cnt70,SELECT_BY_POS,MODE_TRADES)==True)
             {                                                           

             if(OrderType()==OP_BUY) 
                {
                if(OrderSymbol()==Symbol())
                   {                    
                   if(OrderMagicNumber()==MagicNumber)                                          
                      {                       
                  int TSBSelect=1.0;                
               double TSBuyOrderPrice=OrderOpenPrice();              
               double TSBuyTakeProfit=OrderTakeProfit();  
               double TSBuyStopLoss=OrderStopLoss();
                  int TSBuyTicket=OrderTicket();         
                      }
                   }
                 }
             if(OrderType()==OP_SELL)                 
                {
                if(OrderSymbol()==Symbol())                
                   {
                   if(OrderMagicNumber()==MagicNumber)                                          
                      {                   
                  int TSSSelect=1.0;           
               double TSSellOrderPrice=OrderOpenPrice();             
               double TSSellTakeProfit=OrderTakeProfit();    
               double TSSellStopLoss=OrderStopLoss();
                  int TSSellTicket=OrderTicket();
                      }
                    }
                  }              
                                        
            if(TSBSelect==1.0)
               {                                 
	            if((Bid-Low[TSBar])>TSClear)
		             {
	               if(Low[TSBar]<Low[1])
			            {
			            if(Low[TSBar]>TSBuyStopLoss)			        					        					      
		                  {
				     double BTS=Low[TSBar];			  		
                           {					  	
			                  if(OrderModify(TSBuyTicket,TSBuyOrderPrice,BTS,TSBuyTakeProfit,0, Blue)==true) 		   		       
                              {
                             break;
                              }
                             else
                              {
                             RefreshRates();
                             continue;
                              }
                         }
                       }
			            }
			          }
		           }
		                                                      

              if(TSSSelect==1.0) 
                 {                                                                    
                 if((High[TSBar]-Ask)>TSClear)  
		               {
	                 if(High[TSBar]>High[1])
	                    {
	                    if(High[TSBar]<TSSellStopLoss)					      
		 	                 {
				       double STS=High[TSBar];		  						         	  
                            {       			 
			                   if(OrderModify(TSSellTicket,TSSellOrderPrice,STS,TSSellTakeProfit,0,Red)==true) 
                               {
                              break;
                               }
                              else
                               {
                              RefreshRates();
                              continue;
                               }
                             }
                           }
                         }                               
	  			           }	  					
	  		            }	  		 
	  	      }    
         }
       }
     }
//+------------------------------------------------------------------+
//| Stop Trading at Sequencial Limit                                 |
//+------------------------------------------------------------------+     
int IncStop=1;

if(UseShutDownInc)
   {
   if(Xlosses>=SeqLimit+1.0)
      {
      IncStop=0;
      }
   }                
//+------------------------------------------------------------------+
//| Equity Stop Trading                                              |
//+------------------------------------------------------------------+
 int BTStop=1.0; 
 
 if(UseBalanceProfit)
    {    
    if(Balance>=BalanceTarget)
       {
      BTStop = 0;
       }
    } 
//+------------------------------------------------------------------+
//|No Trade Friday                                                   |
//+------------------------------------------------------------------+
int FridayOK =1;

 if(NoTradeFriday)
    {
    if (DayOfWeek() == 5)
        {
        FridayOK=0;
        }
     }          
//+------------------------------------------------------------------+
//| Equity Stop Trading                                             |
//+------------------------------------------------------------------+
 int EOStop=1.0; 
 double BalanceCheck = NormalizeDouble(AccountBalance(),0);
 double AdjustedHIB = NormalizeDouble((InitialBalance+BalChange),0);
 double AdjustedLIB = NormalizeDouble((InitialBalance-BalChange),0);
 
 if(UseBalanceStop)
    {    
    if(BalanceCheck>AdjustedHIB  || BalanceCheck<AdjustedLIB)
       {
      EOStop = 0;
       }
    }
//+------------------------------------------------------------------+
//|Stop Trade on Time                                                |
//+------------------------------------------------------------------+
 int TradeTime=1;
//+------------------------------------------------------------------+
//| Shut Down Trade Days and Nights True                             |
//+------------------------------------------------------------------+
  if(TradeDays==True && TradeNights==True)
     {
     TradeTime=0;
     }
//+------------------------------------------------------------------+
//| Trade Days OK                                                    |
//+------------------------------------------------------------------+    
     
 if(TradeDays)
    { 
     if(h<=7||Hours<=7)
        {
       TradeTime=0;
        }
     if(h>=18||Hours>=18)
        {
        TradeTime=0;
        }
    } 
 
 if(TradeNights)
    {   
     if(h>=7||Hours>=7)
        {
        if(h<=18||Hours<=18)
           {
          TradeTime=0;
           }
        }  
    }  
//+------------------------------------------------------------------+
//|Stop Trade on Free Margin                                         |
//+------------------------------------------------------------------+

double MoveValue   = Plotsi*(MarketInfo(Symbol(), MODE_TICKVALUE)*FMStop);  
double FMStopBal = Balance-MoveValue; 
int  FMOK=1;

if(UseFMLimit)
   {
   if(FMStopBal<FMBalance)
        {
       FMOK=0;
        }
    }    
//+------------------------------------------------------------------+
//| Close EA on Kelly Ratio                                             |
//+------------------------------------------------------------------+
int KellyOK=1;
  if(UseWLClose)
     {
     if(WinPercent<MinWPercent)
        {
       KellyOK=0;
        }
     }
//+------------------------------------------------------------------+
//| General Order Conditions                                         |
//+------------------------------------------------------------------+
if(IncStop==1)
   { 
   if(FridayOK==1)
      {         
      if(FMOK==1)
         {        
         if(TradeTime==1)
            {
            if(EOStop==1)
               {            
               if(BTStop==1)
                  {              
                  if(Equity>=MinimumEquity)
                     {
                     if(KellyOK==1)  
                        {      
                        if(MathAbs(Close[1]-Open[0])<BarCheck)
                           {                           

//+------------------------------------------------------------------+
//|Order Entry Triggers                                              |
//+------------------------------------------------------------------+
int BuyOrder=0;
int SellOrder=0;

//+------------------------------------------------------------------+
//| Primary Order Market Buys                                        |
//+------------------------------------------------------------------+    

     if(UseBuy)
        {                               
        if(OrdersTotal()<MaxTrades)
           {             
           if(Buy==0 && Sell==0)              
              { 
              if(BuyOrder==1)
                 {      
                     
                   if(UseStopLoss)
                           {
                         double B1StopLossLevel = Ask - AStopLoss;
                           }
                         else
                           {
                         B1StopLossLevel=0;
                           }
                   if (UseTakeProfit)
                           { 
                         double B1TakeProfitLevel = Ask + ATakeProfit;      
                           } 
                         else 
                           {
                         B1TakeProfitLevel=0;
                           }  

            while(true)
              {
                Ticket = OrderSend(Symbol(),OP_BUY,Plotsi,Ask,Slippage,B1StopLossLevel,B1TakeProfitLevel,Text1,MagicNumber,0,Blue);    	                
                if(Ticket<0)
                  {
                 RefreshRates();
                 continue;
                  }   
                 else
                  {
                Sleep(20000);
                return(Ticket==OrderTicket());
                //break;  
                  }
              }   
         }
       }                    
     }
   }
//+------------------------------------------------------------------+
//|Primary Order Entry Sell                                          |
//+------------------------------------------------------------------+          

     if(UseSell)
        {
        if(OrdersTotal()<MaxTrades)
           {                                                                     
           if(Sell==0 && Buy==0)
              {
              if(SellOrder==1)
                 {                                                                 
                     if(UseStopLoss) 
                           {
                          double S1StopLossLevel = Bid + AStopLoss;
                           }
                           else
                           {
                          S1StopLossLevel=0;
                           }
                     if(UseTakeProfit)                      
                           {
                          double S1TakeProfitLevel = Bid - ATakeProfit;                                                  
                           } 
                          else
                           {
                          S1TakeProfitLevel=0;                                 
	                        }      

            while(true)
               {
                 Ticket = OrderSend(Symbol(),OP_SELL,Plotsi,Bid,Slippage,S1StopLossLevel,S1TakeProfitLevel,Text2,MagicNumber,0,Red);    	                
                if(Ticket<0)
                  {
                 RefreshRates();
                 continue;
                  }   
                 else
                  {
                Sleep(20000);
                return(Ticket==OrderTicket());
                //break;  
                  }
               }    
        
           }
         }                    
       }
     }

  
//+------------------------------------------------------------------+
//|Price Move Orders                                                 |
//+------------------------------------------------------------------+         
if(PriceOrders)      
   {
double TPMin = 0.001;
//+------------------------------------------------------------------+
//|Price Move Buy Orders                                             |
//+------------------------------------------------------------------+    
       if(OrdersTotal()<MaxTrades)
          {                                          
          if(UseBuy)
             {
             if(Buy>=1)
                {                       
                if((Bid-BuyOrderPrice)>0)
                    {
                    if((Bid-BuyOrderPrice)>PriceMove) 
                        {
                                                            
                
                 if(UseStopLoss)
                        {
                      double BMStopLossLevel = BuyStopLoss;
                        }
                      else
                        {
                      BMStopLossLevel=0;
                        }
                 if (UseTakeProfit)
                        { 
                      double BMTakeProfitLevel = BuyTakeProfit;                            
                        }
                     else 
                        {
                     BMTakeProfitLevel=0;
                        }
            while(true)
              {
                Ticket = OrderSend(Symbol(),OP_BUY,PMlotsi,Ask,Slippage,BMStopLossLevel,BMTakeProfitLevel,Text5,MagicNumber,0,Blue);    	                
                if(Ticket<0)
                  {
                 RefreshRates();
                 continue;
                  }   
                 else
                  {
               return(Ticket==OrderTicket());
                //break;  
                  }
               }    
           }
         }
       }
     }
   }

//+------------------------------------------------------------------+
//|Secondary Sell Orders                                             |
//+------------------------------------------------------------------+               
  
        if(OrdersTotal()<MaxTrades)
           {  
           if(UseSell)
              {
              if(Sell>=1)           
                 {                            
                 if((SellOrderPrice-Ask)>0)
                     {                  
                     if((SellOrderPrice-Ask)>PriceMove) 
                         {                   

  
                    if(UseStopLoss) 
                         {
                       double SMStopLossLevel = SellStopLoss;
                         }
                       else
                         {
                       SMStopLossLevel=0;
                         }
                    if(UseTakeProfit)                      
                         {
                       double SMTakeProfitLevel = SellTakeProfit;                                                  
                         } 
                       else
                         {
                       SMTakeProfitLevel=0;                                 
	                      } 
           while(true)
              {
                 Ticket = OrderSend(Symbol(),OP_SELL,PMlotsi,Bid,Slippage,SMStopLossLevel,SMTakeProfitLevel,Text6,MagicNumber,0,Red);    	                                 
                if(Ticket<0)
                  {
                 RefreshRates();
                 continue;
                  }   
                 else
                  {
                return(Ticket==OrderTicket());
                //break;  
                  }
              }  
            
            }
          }  
        }      
      }
    }
    
  
  }      
//+------------------------------------------------------------------+
//| Order Protect Entry Buy                                          |
//+------------------------------------------------------------------+ 
   if(UseOrderProtect)
      {
//+------------------------------------------------------------------+
//| Order Protect Buy Enter Sell                                     |
//+------------------------------------------------------------------+              
        
            if(OrdersTotal()<MaxTrades)        
               {
               if(UseBuy)
                  {
                  if(Buy==1)
                     {
                     if(Sell==0)              
                        {
                        if((BuyOrderPrice-Ask)>PriceMove)
                            {                         
                   
                   if(UseStopLoss)
                           {
                         double B2StopLossLevel = BuyOrderPrice;//Bid+PrStopLoss;
                           }
                         else
                           {
                         B2StopLossLevel=0;
                           }
                   if (UseTakeProfit)
                           { 
                         double B2TakeProfitLevel = Bid-PTakeProfit;      
                           } 
                         else 
                           {
                         B2TakeProfitLevel=0;
                           }  
           while(true)
              {
                Ticket = OrderSend(Symbol(),OP_SELL,PMlotsi,Bid,Slippage,B2StopLossLevel,B2TakeProfitLevel,Text8,MagicNumber,0,Red);    	                
                if(Ticket<0)
                  {
                 RefreshRates();
                 continue;
                  }   
                 else
                  {
                return(Ticket==OrderTicket());
                //break;  
                  }
               }    
            }
          }
        }
      }
    }         
 
//+------------------------------------------------------------------+
//|Order Protect Sell Enter Buy                                      |
//+------------------------------------------------------------------+          
             if(OrdersTotal()<MaxTrades)              
                {
                 if(UseSell)
                    {
                    if(Sell==1)
                       {
                       if(Buy==0)
                          {
                          if((Bid-SellOrderPrice)>PriceMove)
                              {
                                                            
                     if(UseStopLoss) 
                           {
                          double S2StopLossLevel = SellOrderPrice;//Ask-PrStopLoss;
                           }
                           else
                           {
                          S2StopLossLevel=0;
                           }
                     if(UseTakeProfit)                      
                           {
                          double S2TakeProfitLevel = Ask+PTakeProfit;                                                  
                           } 
                          else
                           {
                          S2TakeProfitLevel=0;                                 
	                        }      
           while(true)
              { 
                 Ticket = OrderSend(Symbol(),OP_BUY,PMlotsi,Ask,Slippage,S2StopLossLevel,S2TakeProfitLevel,Text7,MagicNumber,0,Blue);    	                
                if(Ticket<0)
                  {
                 RefreshRates();
                 continue;
                  }   
                 else
                  {
                return(Ticket==OrderTicket());
                //break;  
                  }
               }               
             
             }
           }
         }
       }
     }                                            
   
   }
                                 
//+------------------------------------------------------------------+
//|End Generic Order Processing Variables                            |
//+------------------------------------------------------------------+
                }//IncStop
              }//BarCheck
            }//WinPercent  
          } //Equity 
        }//Balance Profit
      }//Stop Balance    
    }//Close Time 
  }//FreeMargin   
}//Friday

RefreshRates();
 return(0);
}
 


     

//+------------------------------------------------------------------+